unit Edit;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    FileMnu: TMenuItem;
    FileNew: TMenuItem;
    FileSave: TMenuItem;
    FileLoad: TMenuItem;
    N1: TMenuItem;
    FileExit: TMenuItem;
    FileSaveAs: TMenuItem;
    procedure FileNewClick(Sender: TObject);
    procedure FileSaveClick(Sender: TObject);
    procedure FileSaveAsClick(Sender: TObject);
    procedure FileLoadClick(Sender: TObject);
    procedure FileExitClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FileNewClick(Sender: TObject);
begin
  Memo1.Clear;
  OpenDialog1.Filename := '*.*';
  Caption := 'Text Editor - [Untitled]';
end;

procedure TForm1.FileSaveClick(Sender: TObject);
begin
  if (OpenDialog1.Filename <> '')
     and (OpenDialog1.Filename <> '*.*') then
  begin
    Memo1.Lines.SaveToFile(OpenDialog1.Filename);
  end
  else FileSaveAsClick(Sender);
end;

procedure TForm1.FileSaveAsClick(Sender: TObject);
begin
   with SaveDialog1 do
    if Execute then
    begin
      Memo1.Lines.SaveToFile(Filename);
      Caption := 'Text Editor - ' + ExtractFilename(FileName);
      OpenDialog1.Filename := Filename;
    end;
end;

procedure TForm1.FileLoadClick(Sender: TObject);
begin
  with OpenDialog1 do
    if Execute then
    begin
      Memo1.Lines.LoadFromFile(FileName);
      Caption := 'Text Editor - ' + ExtractFilename(FileName);
    end;
end;

procedure TForm1.FileExitClick(Sender: TObject);
begin
  Close;
end;

end.
