unit Edit2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls,
  IOProcs; 

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    FileMnu: TMenuItem;
    FileNew: TMenuItem;
    FileSave: TMenuItem;
    FileLoad: TMenuItem;
    N1: TMenuItem;
    FileExit: TMenuItem;
    FileSaveAs: TMenuItem;
    procedure FileNewClick(Sender: TObject);
    procedure FileSaveClick(Sender: TObject);
    procedure FileSaveAsClick(Sender: TObject);
    procedure FileLoadClick(Sender: TObject);
    procedure FileExitClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


function ConfirmFileSave(FileName : string) : boolean;
{ put up a dialg box to confirm that the existing file should be
  overwritten. This function returns True if the Yes button is pressed,
  otherwise it returns false. Note that you can test for the
  buttons used in dialogs with these constants: mrNone,mrOk,mrCancel,
  mrAbort,mrRetry,mrIgnore,mrYes,mrNo,mrAbort,mrRetry,mrIgnore,mrAll }

begin
    if MessageDlg(FileName + ' already exists. Save anyway?',
                        mtConfirmation, mbYesNoCancel, 0)
                        = mrYes then
      ConfirmFileSave := true
    else
      ConfirmFileSave := false;
end;

procedure TForm1.FileNewClick(Sender: TObject);
begin
  Memo1.Clear;
  OpenDialog1.Filename := '*.*';
  Caption := 'Text Editor 2 - [Untitled]';
end;

procedure TForm1.FileSaveClick(Sender: TObject);
begin
  if (OpenDialog1.Filename <> '')
     and (OpenDialog1.Filename <> '*.*') then
  begin
    Memo1.Lines.SaveToFile(OpenDialog1.Filename);
  end
  else FileSaveAsClick(Sender);
end;

procedure TForm1.FileSaveAsClick(Sender: TObject);
var
   SaveFile : boolean;
begin
   SaveFile := true;
   with SaveDialog1 do
    if Execute then
    begin
      if ThisFileExists(FileName) then
         SaveFile := ConfirmFileSave(FileName);
      If SaveFile then
      begin
         Memo1.Lines.SaveToFile(Filename);
         Caption := 'Text Editor 2 - ' + ExtractFilename(FileName);
         OpenDialog1.Filename := Filename;
      end;
    end;
end;

procedure TForm1.FileLoadClick(Sender: TObject);
begin
  with OpenDialog1 do
    if Execute then
    begin
      { if the specified file exists it loads it, otherwise
        it displays an error message }
      if ThisFileExists(FileName) Then
      begin
          Memo1.Lines.LoadFromFile(FileName);
          Caption := 'Text Editor 2 - ' + ExtractFilename(FileName);
      end
      else
        MessageDlg('Sorry. Can''t load this file. '+ FileName +
                           ' does not exist!',
                        mtInformation, [mbOK], 0);
    end;
end;

procedure TForm1.FileExitClick(Sender: TObject);
begin
  Close;
end;

end.
